<?php //$Id: backuplib.php,v 1.6.6.1 2007/04/22 22:05:19 stronk7 Exp $
    //This php script contains all the stuff to backup/restore
    //meetingpoint mods

    //This is the "graphical" structure of the meetingpoint mod:
    //
    //                     meetingpoint                                      
    //                 (CL,pk->id,files)
    //
    // Meaning: pk->primary key field of the table
    //          fk->foreign key to link with parent
    //          nt->nested field (recursive data)
    //          CL->course level info
    //          UL->user level info
    //          files->table may have files)
    //
    //-----------------------------------------------------------

    //This function executes all the backup procedure about this mod
    function meetingpoint_backup_mods($bf,$preferences) {
        global $CFG;

        $status = true; 

        ////Iterate over meetingpoint table
        $meetingpoints = get_records ("meetingpoint","course",$preferences->backup_course,"id");
        if ($meetingpoints) {
            foreach ($meetingpoints as $meetingpoint) {
                if (backup_mod_selected($preferences,'meetingpoint',$meetingpoint->id)) {
                    $status = meetingpoint_backup_one_mod($bf,$preferences,$meetingpoint);
                }
            }
        }
        return $status;
    }
   
    function meetingpoint_backup_one_mod($bf,$preferences,$meetingpoint) {

        global $CFG;
    
        if (is_numeric($meetingpoint)) {
            $meetingpoint = get_record('meetingpoint','id',$meetingpoint);
        }
    
        $status = true;

        //Start mod
        fwrite ($bf,start_tag("MOD",3,true));
        //Print assignment data
        fwrite ($bf,full_tag("ID",4,false,$meetingpoint->id));
        fwrite ($bf,full_tag("MODTYPE",4,false,"meetingpoint"));
        fwrite ($bf,full_tag("NAME",4,false,$meetingpoint->name));
        fwrite ($bf,full_tag("SUMMARY",4,false,$meetingpoint->summary));
        fwrite ($bf,full_tag("LAYOUT",4,false,$meetingpoint->layout));
        fwrite ($bf,full_tag("XMLDATA",4,false,$meetingpoint->xmldata));
        fwrite ($bf,full_tag("TIMEMODIFIED",4,false,$meetingpoint->timemodified));
        //End mod
        $status = fwrite ($bf,end_tag("MOD",3,true));

        // backup files for this meetingpoint.
        $status = meetingpoint_backup_files($bf,$preferences,$meetingpoint);

        return $status;
    }

   ////Return an array of info (name,value)
   function meetingpoint_check_backup_mods($course,$user_data=false,$backup_unique_code,$instances=null) {
       if (!empty($instances) && is_array($instances) && count($instances)) {
           $info = array();
           foreach ($instances as $id => $instance) {
               $info += meetingpoint_check_backup_mods_instances($instance,$backup_unique_code);
           }
           return $info;
       }
       //First the course data
       $info[0][0] = get_string("modulenameplural","meetingpoint");
       if ($ids = meetingpoint_ids ($course)) {
           $info[0][1] = count($ids);
       } else {
           $info[0][1] = 0;
       }
       
       return $info;
   }

   ////Return an array of info (name,value)
   function meetingpoint_check_backup_mods_instances($instance,$backup_unique_code) {
        //First the course data
        $info[$instance->id.'0'][0] = '<b>'.$instance->name.'</b>';
        $info[$instance->id.'0'][1] = '';

        return $info;
    }

    //Return a content encoded to support interactivities linking. Every module
    //should have its own. They are called automatically from the backup procedure.
    function meetingpoint_encode_content_links ($content,$preferences) {

        global $CFG;

        $base = preg_quote($CFG->wwwroot,"/");

        //Link to the list of meetingpoints
        $buscar="/(".$base."\/mod\/meetingpoint\/index.php\?id\=)([0-9]+)/";
        $result= preg_replace($buscar,'$@meetingpointINDEX*$2@$',$content);

        //Link to meetingpoint view by moduleid
        $buscar="/(".$base."\/mod\/meetingpoint\/view.php\?id\=)([0-9]+)/";
        $result= preg_replace($buscar,'$@meetingpointVIEWBYID*$2@$',$result);

        //Link to meetingpoint view by meetingpointid
        $buscar="/(".$base."\/mod\/meetingpoint\/view.php\?r\=)([0-9]+)/";
        $result= preg_replace($buscar,'$@meetingpointVIEWBYR*$2@$',$result);

        return $result;
    }

    // INTERNAL FUNCTIONS. BASED IN THE MOD STRUCTURE

    //Returns an array of meetingpoints id
    function meetingpoint_ids ($course) {

        global $CFG;

        return get_records_sql ("SELECT a.id, a.course
                                 FROM {$CFG->prefix}meetingpoint a
                                 WHERE a.course = '$course'");
    }
   
    function meetingpoint_backup_files($bf,$preferences,$meetingpoint) {
        global $CFG;
        $status = true;

        // now, just in case we check moddata ( going forwards, meetingpoints should use this )
        $status = $status && check_and_create_moddata_dir($preferences->backup_unique_code);
        $status = $status && check_dir_exists($CFG->dataroot."/temp/backup/".$preferences->backup_unique_code."/".$CFG->moddata."/meetingpoint",true);
        
        if ($status) {
            //Only if it exists !! Thanks to Daniel Miksik.
            if (is_dir($CFG->dataroot."/".$preferences->backup_course."/".$CFG->moddata."/meetingpoint")) {
                $status = backup_copy_file($CFG->dataroot."/".$preferences->backup_course."/".$CFG->moddata."/meetingpoint",
                                           $CFG->dataroot."/temp/backup/".$preferences->backup_unique_code."/moddata/meetingpoint");
            }
        }

        return $status;
    }

?>
