<?php
    $openofficexts = array('123','bmp','cgm','csv','dbf','dif','doc','dot','dxf','emf','eps','htm',
                             'html','hwp','jtd','jtt','met','mml','odb','odf','odg','odm','odp','ods',
                             'odt','otg','oth','otp','ots','ott','pbm','pcd','pct','pcx','pdb','pgm',
                             'pot','ppm','pps','ppt','psd','psw','pxl','ras','rtf','sda','sdc','sdd',
                             'sdp','sdw','sgf','sgl','sgv','slk','smf','stc','std','sti','stw','svm',
                             'sxc','sxd','sxg','sxi','sxm','sxw','tga','tiff','txt','vor','wk1','wks',
                             'wmf','wpd','wps','xbm','xls','xlt','xlw','xml','xpm');
    $swftoolsexts = array('gif','pdf','png');
    $flashexts = array('swf','jpeg','jpg','jpe','jfif','jif','jfi');

    $convertablexts = $flashexts;
    if (isset($CFG->meetingpoint_gif2swf) && !empty($CFG->meetingpoint_gif2swf)) {
        $convertablexts[] = 'gif';
    }
    if (isset($CFG->meetingpoint_pdf2swf) && !empty($CFG->meetingpoint_pdf2swf)) {
        $convertablexts[] = 'pdf';
    }
    if (isset($CFG->meetingpoint_png2swf) && !empty($CFG->meetingpoint_png2swf)) {
        $convertablexts[] = 'png';
    }
    if (isset($CFG->meetingpoint_python) && !empty($CFG->meetingpoint_python)) {
        $convertablexts = array_merge($convertablexts, $openofficexts);
    }

    function meetingpoint_convert ($course, $filename) {
        global $CFG;
        global $openofficexts, $swftoolsexts, $flashexts;

        $return = false;

        $used_openoffice = false;

        $inputfile = null;
        $outputfile = null;

        if (eregi('\.([a-z0-9]+)$', $filename, $match)) {
            $extension = strtolower($match[1]);
            if (!$return && in_array($extension,$flashexts)) {
                $outputfile = '/'.$course.'/'.$CFG->moddata.'/meetingpoint/converted/'.$filename.'.swf';
                $inputfile = '/'.$course.'/'.$filename;
                if ($outputdir = make_upload_directory(dirname($outputfile))) {
                    if (file_exists($CFG->dataroot.$inputfile)) {
                        copy($CFG->dataroot.$inputfile,$CFG->dataroot.$outputfile);
                        $return = true;
                    }
                }
            }

            if (!$return && !empty($CFG->meetingpoint_python) && in_array($extension,$openofficexts)) {
                // I must use OpenOffice
                if (file_exists($CFG->meetingpoint_python)) {
                    $documentconverter = $CFG->dirroot.'/mod/meetingpoint/files/DocumentConverter.py';
                    $outputfile = '/'.$course.'/'.$CFG->moddata.'/meetingpoint/temp/'.$filename.'.pdf';
                    $inputfile = '/'.$course.'/'.$filename;
                    if ($outputdir = make_upload_directory(dirname($outputfile))) {
                        if (file_exists($CFG->dataroot.$inputfile)) {
                            exec(escapeshellcmd($CFG->meetingpoint_python).' '.escapeshellarg($documentconverter).' '.escapeshellarg($CFG->dataroot.$inputfile).' '.escapeshellarg($CFG->dataroot.$outputfile));
                            if (file_exists($CFG->dataroot.$outputfile)) {
                                $extension = 'pdf';
                                $used_openoffice = true;
                            }
                        }
                    }
                }
            }
            if (!$return && in_array($extension,$swftoolsexts)) {
                // I can use SWFTools
                $inputfile = $used_openoffice?$outputfile:'/'.$course.'/'.$filename;
                $outputfile = '/'.$course.'/'.$CFG->moddata.'/meetingpoint/converted/'.$filename.'.swf';
                switch ($extension) {
                    case 'gif':
                        if (!empty($CFG->meetingpoint_gif2swf) && file_exists($CFG->meetingpoint_gif2swf)) {
                            if ($outputdir = make_upload_directory(dirname($outputfile))) {
                                if (file_exists($CFG->dataroot.$inputfile)) {
                                    exec(escapeshellcmd($CFG->meetingpoint_gif2swf).' -v 0 -o '.escapeshellarg($CFG->dataroot.$outputfile).' '.escapeshellarg($CFG->dataroot.$inputfile));
                                    if (file_exists($CFG->dataroot.$outputfile)) {
                                        $return = true;
                                    }
                                }
                            }
                        }
                    break;
                    case 'png':
                        if (!empty($CFG->meetingpoint_png2swf) && file_exists($CFG->meetingpoint_png2swf)) {
                            if ($outputdir = make_upload_directory(dirname($outputfile))) {
                                if (file_exists($CFG->dataroot.$inputfile)) {
                                    exec(escapeshellcmd($CFG->meetingpoint_png2swf).' -v 0 -o '.escapeshellarg($CFG->dataroot.$outputfile).' '.escapeshellarg($CFG->dataroot.$inputfile));
                                    if (file_exists($CFG->dataroot.$outputfile)) {
                                        $return = true;
                                    }
                                }
                            }
                        }
                    break;
                    case 'pdf':
                        if (!empty($CFG->meetingpoint_pdf2swf) && file_exists($CFG->meetingpoint_pdf2swf)) {
                            if ($outputdir = make_upload_directory(dirname($outputfile))) {
                                if (file_exists($CFG->dataroot.$inputfile)) {
                                    exec(escapeshellcmd($CFG->meetingpoint_pdf2swf).' -q -s insertstop '.escapeshellarg($CFG->dataroot.$inputfile).' -o '.escapeshellarg($CFG->dataroot.$outputfile));
                                    if (file_exists($CFG->dataroot.$outputfile)) {
                                        $return = true;
                                    }
                                    if ($used_openoffice) {
                                        // Remove Temporary file
                                        fulldelete($CFG->dataroot.$inputfile);
                                    }
                                }
                            }
                        }
                    break;
                }
            }
        }
        return $return;
    }

?>
