<?php  // $Id: index.php,v 1.27 2006/09/02 11:44:04 skodak Exp $

    require_once('../../config.php');
    require_once('lib.php');

    $id = required_param('id',PARAM_INT);   // course

    if (! $course = get_record('course', 'id', $id)) {
        error('Course ID is incorrect');
    }

    require_course_login($course);

    add_to_log($course->id, 'meetingpoint', 'view all', "index?id=$course->id", '');

    $strmeetingpoint = get_string('modulename', 'meetingpoint');
    $strmeetingpoints = get_string('modulenameplural', 'meetingpoint');

    $navlinks = array();
    $navlinks[] = array('name' => $strmeetingpoints, 'link' => '', 'type' => 'activity');
    $navigation = build_navigation($navlinks);

    print_header_simple("$strmeetingpoints", '', $navigation, '', '', true, '', navmenu($course));


    if (! $meetingpoints = get_all_instances_in_course('meetingpoint', $course)) {
        notice('There are no meetingpoints', "../../course/view.php?id=$course->id");
    }


    $timenow = time();

    if ($course->format == 'weeks') {
        $table->head  = array (get_string('week'), get_string('modulename','meetingpoint'));
        $table->align = array ('center', 'left');
    } else if ($course->format == 'topics') {
        $table->head  = array (get_string('topic'), get_string('modulename','meetingpoint'));
        $table->align = array ('center', 'left');
    } else {
        $table->head  = array (get_string('modulename','meetingpoint'));
        $table->align = array ('left');
    }

    $currentsection = '';

    foreach ($meetingpoints as $meetingpoint) {
        $printsection = "";
        if ($meetingpoint->section !== $currentsection) {
            if ($meetingpoint->section) {
                $printsection = $meetingpoint->section;
            }
            if ($currentsection !== "") {
                $table->data[] = 'hr';
            }
            $currentsection = $meetingpoint->section;
        }
        
        //Calculate the href
        if (!$meetingpoint->visible) {
            //Show dimmed if the mod is hidden
            $tt_href = "<a class=\"dimmed\" href=\"view.php?id=$meetingpoint->coursemodule\">".format_string($meetingpoint->name,true)."</a>";
        } else {
            //Show normal if the mod is visible
            $tt_href = "<a href=\"view.php?id=$meetingpoint->coursemodule\">".format_string($meetingpoint->name,true)."</a>";
        }
        if ($course->format == "weeks" || $course->format == "topics") {
            $table->data[] = array ($printsection, $tt_href);
        } else {
            $table->data[] = array ($tt_href);
        }
    }
    echo "<br />";
    print_table($table);

    print_footer($course);
 
?>

