<?php

if (!isset($CFG->meetingpoint_serverhost)) {
    set_config('meetingpoint_serverhost','localhost');
}
if (!isset($CFG->meetingpoint_serverprotocol)) {
    set_config('meetingpoint_serverprotocol','rtmp');
}
if (!isset($CFG->meetingpoint_serverport)) {
    set_config('meetingpoint_serverport',1935);
}
if (!isset($CFG->meetingpoint_roomprefix)) {
    set_config('meetingpoint_roomprefix','');
}
if (!isset($CFG->meetingpoint_openoffice)) {
    set_config('meetingpoint_openoffice','');
}
if (!isset($CFG->meetingpoint_gif2swf)) {
    set_config('meetingpoint_gif2swf','');
}
if (!isset($CFG->meetingpoint_png2swf)) {
    set_config('meetingpoint_png2swf','');
}
if (!isset($CFG->meetingpoint_pdf2swf)) {
    set_config('meetingpoint_pdf2swf','');
}

function meetingpoint_get_layouts() {
    
    $layouts = array();
    $layouts['meeting'] = get_string('meeting','meetingpoint');
    $layouts['lesson'] = get_string('lesson','meetingpoint');
    $layouts['broadcast'] = get_string('broadcast','meetingpoint');
    $layouts['videoconference'] = get_string('videoconference','meetingpoint');

    return $layouts;
}

function meetingpoint_getcomponents() {
    global $CFG;

    $components = array();
    if ($componentfiles = meetingpoint_scandir($CFG->dirroot.'/mod/meetingpoint/components')) {

        foreach ($componentfiles as $componentfile) {
            if ((substr($componentfile,0,1) != '.') && ($componentfile!='component.php') && eregi('\.([a-z0-9]+)$', $componentfile, $match)) {
                $extension = strtolower($match[1]);
                if ($extension == 'php') {
                    $components[] = substr($componentfile,0,-4);
                } 
            }
        }

    }
    return $components;
}

/**
* Given a diretory path returns the file list
*
* @param string $directory
* @return array
*/
function meetingpoint_scandir($directory) {
    if (is_dir($directory)) {
        if (version_compare(phpversion(),'5.0.0','>=')) {
            return scandir($directory);
        } else {
            $files = array();
            if ($dh = opendir($directory)) {
                while (($file = readdir($dh)) !== false) {
                   $files[] = $file;
                }       
                closedir($dh);
            }       
            return $files; 
        }
    }
}

function meetingpoint_getXMLFileList ($directory,$level) {
      global $CFG;

      if (is_dir($CFG->dataroot.$directory)) {
          $slashconnector = $CFG->slasharguments?'':'?file=';
          $files = meetingpoint_scandir($CFG->dataroot.$directory);
          set_time_limit(0);
          foreach($files as $file) {
              if (($file != '.') && ($file != '..')) {
                  if (!is_dir($CFG->dataroot.$directory.'/'.$file)) {
                      if (is_readable($CFG->dataroot.$directory.'/'.$file)) {
                          $file_size = display_size(filesize($CFG->dataroot.$directory.'/'.$file));
                          $file_date = userdate(filemtime($CFG->dataroot.$directory.'/'.$file), "%d %b %Y, %I:%M %p");
                          $filename = substr($file,0,strpos($file,'.swf'));
                          echo '<file name="'.$filename.'" url="'.$CFG->wwwroot.'/file.php'.$slashconnector.$directory.'/'.$file.'" size="'.$file_size.'" date="'.$file_date.'" />'."\n";
                      }
                  } else {
                      if (is_executable($CFG->dataroot.$directory.'/'.$file)) {
                          meetingpoint_getXMLFileList($directory.'/'.$file,$level+1);
                      }
                  }
              }
          }
      } else {
          echo 'false';
      }

  }

?>
