<?php
    require_once('../../config.php');

    $id = required_param('id', PARAM_INT);

    if (!empty($id)) {
        if (! $cm = get_coursemodule_from_id('meetingpoint', $id)) {
            error('Course Module ID was incorrect');
        }
        if (! $course = get_record('course', 'id', $cm->course)) {
            error('Course is misconfigured');
        }
        if (! $meetingpoint = get_record('meetingpoint', 'id', $cm->instance)) {
            error('Course module is incorrect');
        }
    }

    require_login($course->id, false, $cm);

    if (confirm_sesskey()) {
        if (!isset($CFG->meetingpoint_roomprefix)) {
            $CFG->meetingpoint_roomprefix = '';
        }
    
        if (!isset($CFG->meetingpoint_serverprotocol)) {
            $CFG->meetingpoint_serverprotocol = 'rtmp';
        }
    
        if (!isset($CFG->meetingpoint_serverhost)) {
            $CFG->meetingpoint_serverhost = $_SERVER['SERVER_NAME'];
        }
    
        if (!isset($CFG->meetingpoint_serverport)) {
            $CFG->meetingpoint_serverport = '1935';
        }

        if (!isset($CFG->meetingpoint_autoconnect)) {
            $CFG->meetingpoint_autoconnect = 'true';
        }

        if (!isset($CFG->meetingpoint_auth_id)) {
            $CFG->meetingpoint_auth_id = 'test';
        }

        if (!isset($CFG->meetingpoint_auth_token)) {
            $CFG->meetingpoint_auth_token = 'test';
        }

        if (!isset($CFG->meetingpoint_auth_domain)) {
            $CFG->meetingpoint_auth_domain = $_SERVER['SERVER_NAME'];
        }

        $role = 'guest';
        $role = has_capability('mod/meetingpoint:user', get_context_instance(CONTEXT_MODULE,$cm->id))?'user':$role;
        $role = has_capability('mod/meetingpoint:moderator', get_context_instance(CONTEXT_MODULE,$cm->id))?'moderator':$role;
        $role = has_capability('mod/meetingpoint:poweruser', get_context_instance(CONTEXT_MODULE,$cm->id))?'poweruser':$role;

        $lang = isset($USER->lang)?str_replace('_utf8','',$USER->lang):'en';
		
        echo '<user name="'.htmlentities($USER->username).'" fullname="'.htmlentities(fullname($USER)).'" id="'.$USER->id.'" role="'.$role.'" authentication_id="'.$CFG->meetingpoint_auth_id.'" authentication_token="'.$CFG->meetingpoint_auth_token.'"  authentication_domain="'.$CFG->meetingpoint_auth_domain.'" />'."\n";

        echo '<application languageURI="'.$CFG->wwwroot.'/mod/meetingpoint/translate.php" language="'.$lang.'" />'."\n";

        echo '<connection autoconnect="'.$CFG->meetingpoint_autoconnect.'" protocol="'.$CFG->meetingpoint_serverprotocol.'" host="'.$CFG->meetingpoint_serverhost.'" port="'.$CFG->meetingpoint_serverport.'" application="Meeting" room="'.$CFG->meetingpoint_roomprefix.md5('ROOM'.$meetingpoint->id).'" />'."\n";

	//$com_get_path = $CFG->wwwroot.'/mod/meetingpoint/swf/get.php';
	$componentsroot = $CFG->wwwroot.'/mod/meetingpoint/swf/';
        //echo '<windowmanager URL="'.$com_get_path.'?a='.$meetingpoint->id.'&c=WM&t='.time().'" menu="'.$CFG->wwwroot.'/mod/meetingpoint/swf/menu.xml.php?id='.$id.'" />'."\n";
        echo '<windowmanager URL="'.$componentsroot.'WM.swf" menu="'.$CFG->wwwroot.'/mod/meetingpoint/swf/menu.xml.php?id='.$id.'" />'."\n";

        require_once($CFG->dirroot.'/mod/meetingpoint/locallib.php');
    
        echo "\n<components>\n";
        if ($components = meetingpoint_getcomponents()) {
            $now = time();
            require_once($CFG->dirroot.'/mod/meetingpoint/components/component.php');
            foreach($components as $component) {
                require_once($CFG->dirroot.'/mod/meetingpoint/components/'.$component.'.php');
    
                $componentclass = 'meetingpoint_'.$component;
    
                $comp = new $componentclass($meetingpoint);
    
                $label = $comp->title;
    
                $param = isset($comp->param)?' param="'.$comp->param.'"':'';
    
                switch ($comp->type) {
                    case 'embedded':
                        echo "\t".'<embedded contentPath="'.$comp->contentPath.'" label="'.$label.'"'.$param.' />'."\n";
                    break;
                    case 'preloaded':
                        //$esc_url = $com_get_path .'?a='.$meetingpoint->id.'&c='.$comp->name.'&t='.$now;
                        //echo "\t".'<preloaded URL="'.$esc_url.'" label="'.$label.'"'.$param.' />'."\n";
                        echo "\t".'<preloaded URL="'.$componentsroot.$comp->URL.'" label="'.$label.'"'.$param.' />'."\n";
                    break;
                    case 'external':
                        //$esc_url = $com_get_path.'?a='.$meetingpoint->id.'&c='.$comp->name.'&t='.$now;
                        //echo "\t".'<external URL="'.$esc_url.'" label="'.$label.'"'.$param.' />'."\n";
                        echo "\t".'<external URL="'.$componentsroot.$comp->URL.'" label="'.$label.'"'.$param.' />'."\n";
                    break;
                }
            }
        }
        echo "</components>\n";
    }
?>

