<?php
    require_once('../../../config.php');

    $id = required_param('id', PARAM_INT);

    if (!empty($id)) {
        if (! $cm = get_coursemodule_from_id('meetingpoint', $id)) {
            error('Course Module ID was incorrect');
        }
        if (! $course = get_record('course', 'id', $cm->course)) {
            error('Course is misconfigured');
        }
        if (! $meetingpoint = get_record('meetingpoint', 'id', $cm->instance)) {
            error('Course module is incorrect');
        }
    }

    require_login($course->id, false, $cm);


echo '<?xml version="1.0" ?> ' 

?>
<menu label="Components">
</menu>

<menu label="Layout" >
<!--	<menuitem label="Lesson" action="function" callback="setLayout" param="Lesson" />
	<menuitem label="Meeting" action="function" callback="setLayout" param="Meeting" />
	<menuitem label="A/V" action="function" callback="setLayout" param="A/V"  />
	<menuitem type="separator" /> 
-->

<?php
        if(has_capability('mod/meetingpoint:poweruser', get_context_instance(CONTEXT_COURSE,$cm->id))){
?>
	<menuitem selected="true"  type="check" label="Share Layout" action="function" callback="shareLayout" object="_parent" />
	<menuitem type="separator" /> 
<?php 
}
?>
	<menuitem type="check" label="FullScreen" action="function" callback="doFullScreen" />
</menu>

<menu label="Connection">
	<menuitem label="Connect" action="function" callback="connectAll" object="_parent" />
	<menuitem label="Disconnect" action="function" callback="disconnectAll" object="_parent" />
<!--	<menuitem label="Upload File" action="function" callback="fileUpload" object="_parent"  param="http://stream.mfn.unipmn.it:8080/upload.php" />
	<menuitem type="separator" /> 
	<menuitem label="Bandwidth" >
		<menuitem label="Modem" action="function" callback="setBandwidth" param="Modem" object="_parent" />
		<menuitem label="Adsl" action="function" callback="setBandwidth" param="Adsl" object="_parent" />
		<menuitem label="LAN" action="function" callback="setBandwidth"  param="LAN" object="_parent" />
	</menuitem>
-->
</menu>

<menu label="Settings">
	<menuitem label="Capabilities" action="function" callback="capabilities" object="_parent" />
	<menuitem type="separator" /> 
	<menuitem label="Auth Settings" action="function" callback="showSettings" param="auth" object="_parent" />
	<menuitem label="Video Settings" action="function" callback="showSettings" param="video" object="_parent" />
	<menuitem label="Audio Settings" action="function" callback="showSettings" param="audio" object="_parent" />
	<menuitem type="separator" /> 
	<menuitem label="Media" >
		<menuitem label="Webcam Resolution" >
			<menuitem type="radio" groupName="setResolution_group" label="120x90" action="function" callback="setResolution" param="120x90" object="_parent" />
			<menuitem selected="true"  type="radio" groupName="setResolution_group" label="160x120" action="function" callback="setResolution" param="160x120" object="_parent" />
			<menuitem type="radio" groupName="setResolution_group" label="240x180" action="function" callback="setResolution"  param="240x180" object="_parent" />
			<menuitem type="radio" groupName="setResolution_group" label="320x240" action="function" callback="setResolution"  param="320x240" object="_parent" />
			<menuitem type="radio" groupName="setResolution_group" label="420x315" action="function" callback="setResolution"  param="420x315" object="_parent" />
			<menuitem type="radio" groupName="setResolution_group" label="640x480" action="function" callback="setResolution"  param="640x480" object="_parent" />
			<menuitem type="radio" groupName="setResolution_group" label="800x600" action="function" callback="setResolution"  param="800x600" object="_parent" />
			<menuitem type="radio" groupName="setResolution_group" label="1024x768" action="function" callback="setResolution"  param="1024x768" object="_parent" />
			<menuitem type="radio" groupName="setResolution_group" label="1280x1024" action="function" callback="setResolution"  param="1280x1024" object="_parent" />
			<menuitem type="radio" groupName="setResolution_group" label="1280x800" action="function" callback="setResolution"  param="1280x800" object="_parent" />
		</menuitem>
		<menuitem label="Webcam FPS" >
			<menuitem type="radio" groupName="setFPS_group" label="5" action="function" callback="setFPS" param="5" object="_parent" />
			<menuitem selected="true" type="radio" groupName="setFPS_group" label="10" action="function" callback="setFPS" param="10" object="_parent" />
			<menuitem type="radio" groupName="setFPS_group" label="15" action="function" callback="setFPS"  param="15" object="_parent" />
			<menuitem type="radio" groupName="setFPS_group" label="25" action="function" callback="setFPS"  param="20" object="_parent" />
		</menuitem>
		<menuitem type="separator" /> 
		<menuitem label="Microphone Frequency" >
			<menuitem type="radio" groupName="setRate_group" label="5.000Hz" action="function" callback="setRate" param="5" object="_parent" />
			<menuitem type="radio" groupName="setRate_group" label="8.000Hz" action="function" callback="setRate" param="8" object="_parent" />
			<menuitem selected="true" type="radio" groupName="setRate_group" label="11.000Hz" action="function" callback="setRate" param="11" object="_parent" />
			<menuitem type="radio" groupName="setRate_group" label="22.000Hz" action="function" callback="setRate" param="22" object="_parent" />
			<menuitem type="radio" groupName="setRate_group" label="44.000Hz" action="function" callback="setRate"  param="44" object="_parent" />
		</menuitem>
	</menuitem>
</menu>

<menu label="About">

	<menuitem label="License" action="function" callback="license" object="_parent" />

	<menuitem label="About" action="function" callback="about" object="_parent" />
	
</menu>

<?php
        if(has_capability('mod/meetingpoint:debug', get_context_instance(CONTEXT_MODULE,$cm->id))){
?>
<menu label="Debug" >
	<menuitem label="Logs" action="function" callback="logs" object="_parent" />
	<menuitem label="Vars" action="function" callback="vars" object="_parent" />
</menu>
<?php
}
?>
